Index: uspace/lib/softint/generic/comparison.c
===================================================================
--- uspace/lib/softint/generic/comparison.c	(revision 33b8d024bc268f2773c26e74a40dada11bb71e58)
+++ uspace/lib/softint/generic/comparison.c	(revision 2467b4174c7fecef314011212ab09a004872362d)
@@ -34,5 +34,4 @@
  */
 
-#include <alias.h>
 #include <comparison.h>
 #include <lltype.h>
@@ -42,5 +41,5 @@
 #define GREATER 2;
 
-int __cmpti2 (long long a, long long b)
+int __cmpdi2 (long long a, long long b)
 {
 	union lltype lla;
@@ -65,5 +64,5 @@
 }
 
-int __ucmpti2 (unsigned long long a, unsigned long long b)
+int __ucmpdi2 (unsigned long long a, unsigned long long b)
 {
 	union lltype lla;
@@ -88,33 +87,4 @@
 }
 
-#if LONG_MAX == LLONG_MAX
-int ALIAS(__cmp, i2);
-int ALIAS(__ucmp, i2);
-#else
-
-int __cmpdi2(long a, long b)
-{
-	if ((int)a < (int)b) {
-		return LESSER;
-	} else if ((int)a > (int)b) {
-		return GREATER;
-	} else {
-		return EQUAL;
-	}
-}
-
-int __ucmpdi2(unsigned long a, unsigned long b)
-{
-	if ((int)a < (int)b) {
-		return LESSER;
-	} else if ((int)a > (int)b) {
-		return GREATER;
-	} else {
-		return EQUAL;
-	}
-}
-
-#endif
-
 /** @}
  */
Index: uspace/lib/softint/generic/division.c
===================================================================
--- uspace/lib/softint/generic/division.c	(revision 33b8d024bc268f2773c26e74a40dada11bb71e58)
+++ uspace/lib/softint/generic/division.c	(revision 2467b4174c7fecef314011212ab09a004872362d)
@@ -35,5 +35,4 @@
  */
 
-#include <alias.h>
 #include <division.h>
 
@@ -122,5 +121,5 @@
 
 /* 64bit integer division */
-long long __divti3(long long a, long long b)
+long long __divdi3(long long a, long long b)
 {
 	unsigned long long rem;
@@ -141,5 +140,5 @@
 
 /* 64bit unsigned integer division */
-unsigned long long __udivti3(unsigned long long a, unsigned long long b)
+unsigned long long __udivdi3(unsigned long long a, unsigned long long b)
 {
 	unsigned long long rem;
@@ -161,5 +160,5 @@
 
 /* 64bit remainder of the signed division */
-long long __modti3(long long a, long long b)
+long long __moddi3(long long a, long long b)
 {
 	unsigned long long rem;
@@ -182,5 +181,5 @@
 
 /* 64bit remainder of the unsigned division */
-unsigned long long __umodti3(unsigned long long a, unsigned long long b)
+unsigned long long __umoddi3(unsigned long long a, unsigned long long b)
 {
 	unsigned long long rem;
@@ -203,9 +202,4 @@
 }
 
-int __divmodsi4(int a, int b, int *c)
-{
-	return __divmodsi3(a, b, c);
-}
-
 unsigned int __udivmodsi3(unsigned int a, unsigned int b,
     unsigned int *c)
@@ -214,11 +208,5 @@
 }
 
-unsigned int __udivmodsi4(unsigned int a, unsigned int b,
-    unsigned int *c)
-{
-	return divandmod32(a, b, c);
-}
-
-long long __divmodti3(long long a, long long b, long long *c)
+long long __divmoddi3(long long a, long long b, long long *c)
 {
 	unsigned long long rem;
@@ -234,6 +222,5 @@
 }
 
-
-long long __divmodti4(long long a, long long b, long long *c)
+long long __divmoddi4(long long a, long long b, long long *c)
 {
 	unsigned long long rem;
@@ -249,5 +236,5 @@
 }
 
-unsigned long long __udivmodti3(unsigned long long a, unsigned long long b,
+unsigned long long __udivmoddi3(unsigned long long a, unsigned long long b,
     unsigned long long *c)
 {
@@ -255,18 +242,9 @@
 }
 
-unsigned long long __udivmodti4(unsigned long long a, unsigned long long b,
+unsigned long long __udivmoddi4(unsigned long long a, unsigned long long b,
     unsigned long long *c)
 {
 	return divandmod64(a, b, c);
 }
-
-long ALIAS(__div, i3);
-long ALIAS(__mod, i3);
-long ALIAS(__divmod, i3);
-long ALIAS(__divmod, i4);
-unsigned long ALIAS(__udiv, i3);
-unsigned long ALIAS(__umod, i3);
-unsigned long ALIAS(__udivmod, i3);
-unsigned long ALIAS(__udivmod, i4);
 
 /** @}
Index: uspace/lib/softint/generic/multiplication.c
===================================================================
--- uspace/lib/softint/generic/multiplication.c	(revision 33b8d024bc268f2773c26e74a40dada11bb71e58)
+++ uspace/lib/softint/generic/multiplication.c	(revision 2467b4174c7fecef314011212ab09a004872362d)
@@ -35,5 +35,4 @@
  */
 
-#include <alias.h>
 #include <multiplication.h>
 #include <stdint.h>
@@ -68,5 +67,5 @@
  *
  */
-long long __multi3 (long long a, long long b)
+long long __muldi3 (long long a, long long b)
 {
 	char neg = 0;
@@ -121,13 +120,4 @@
 }
 
-#if LONG_MAX == LLONG_MAX
-long ALIAS(__mul, i3);
-#else
-long __muldi3(long a, long b)
-{
-	return (int)a * (int)b;
-}
-#endif
-
 /** @}
  */
Index: uspace/lib/softint/generic/shift.c
===================================================================
--- uspace/lib/softint/generic/shift.c	(revision 33b8d024bc268f2773c26e74a40dada11bb71e58)
+++ uspace/lib/softint/generic/shift.c	(revision 2467b4174c7fecef314011212ab09a004872362d)
@@ -34,9 +34,8 @@
  */
 
-#include <alias.h>
 #include <shift.h>
 #include <lltype.h>
 
-long long __ashlti3 (long long val, int shift)
+long long __ashldi3 (long long val, int shift)
 {
 	union lltype ll;
@@ -66,5 +65,5 @@
 }
 
-long long __ashrti3 (long long val, int shift)
+long long __ashrdi3 (long long val, int shift)
 {
 	union lltype ll;
@@ -96,5 +95,5 @@
 }
 
-long long __lshrti3 (long long val, int shift)
+long long __lshrdi3 (long long val, int shift)
 {
 	union lltype ll;
@@ -126,34 +125,11 @@
 long long __aeabi_llsl(long long val, int shift)
 {
-	return __ashlti3(val, shift);
+	return __ashldi3(val, shift);
 }
 
 long long __aeabi_llsr(long long val, int shift)
 {
-	return __lshrti3(val, shift);
+	return __lshrdi3(val, shift);
 }
-
-#if LONG_MAX == LLONG_MAX
-long ALIAS(__ashl, i3);
-long ALIAS(__ashr, i3);
-long ALIAS(__lshr, i3);
-#else
-
-long __ashldi3(long val, int shift)
-{
-	return ((int) val) << shift;
-}
-
-long __ashrdi3(long val, int shift)
-{
-	return ((int) val) >> shift;
-}
-
-long __lshrdi3(long val, int shift)
-{
-	return ((unsigned int) val) >> shift;
-}
-
-#endif
 
 /** @}
Index: uspace/lib/softint/include/alias.h
===================================================================
--- uspace/lib/softint/include/alias.h	(revision 33b8d024bc268f2773c26e74a40dada11bb71e58)
+++ 	(revision )
@@ -1,49 +1,0 @@
-/*
- * Copyright (c) 2011 Petr Koupy
- * All rights reserved.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- *
- * - Redistributions of source code must retain the above copyright
- *   notice, this list of conditions and the following disclaimer.
- * - Redistributions in binary form must reproduce the above copyright
- *   notice, this list of conditions and the following disclaimer in the
- *   documentation and/or other materials provided with the distribution.
- * - The name of the author may not be used to endorse or promote products
- *   derived from this software without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
- * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
- * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
- * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
- * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
- * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
- * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
- * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
- * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
- * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
- */
-
-/** @addtogroup softint
- * @{
- */
-
-#ifndef __SOFTINT_ALIAS_H__
-#define __SOFTINT_ALIAS_H__
-
-#include <limits.h>
-
-/* A utility macro for creating aliases for type `long`. */
-
-#if LONG_MAX == LLONG_MAX
-#define ALIAS(pre, post) pre##d##post() __attribute__((alias(#pre "t" #post)))
-#else
-#define ALIAS(pre, post) pre##d##post() __attribute__((alias(#pre "s" #post)))
-#endif
-
-#endif
-
-/** @}
- */
Index: uspace/lib/softint/include/comparison.h
===================================================================
--- uspace/lib/softint/include/comparison.h	(revision 33b8d024bc268f2773c26e74a40dada11bb71e58)
+++ uspace/lib/softint/include/comparison.h	(revision 2467b4174c7fecef314011212ab09a004872362d)
@@ -38,10 +38,8 @@
 
 /* Signed comparison (a < b => 0, a == b => 1, a > b => 2). */
-extern int __cmpdi2(long, long);
-extern int __cmpti2(long long, long long);
+extern int __cmpdi2(long long, long long);
 
 /* Unsigned comparison (a < b => 0, a == b => 1, a > b => 2). */
-extern int __ucmpdi2(unsigned long, unsigned long);
-extern int __ucmpti2(unsigned long long, unsigned long long);
+extern int __ucmpdi2(unsigned long long, unsigned long long);
 
 #endif
Index: uspace/lib/softint/include/division.h
===================================================================
--- uspace/lib/softint/include/division.h	(revision 33b8d024bc268f2773c26e74a40dada11bb71e58)
+++ uspace/lib/softint/include/division.h	(revision 2467b4174c7fecef314011212ab09a004872362d)
@@ -38,37 +38,23 @@
 
 extern int __divsi3(int, int);
-extern long __divdi3(long, long);
-extern long long __divti3(long long, long long);
+extern long long __divdi3(long long, long long);
 
 extern unsigned int __udivsi3(unsigned int, unsigned int);
-extern unsigned long __udivdi3(unsigned long, unsigned long);
-extern unsigned long long __udivti3(unsigned long long, unsigned long long);
+extern unsigned long long __udivdi3(unsigned long long, unsigned long long);
 
 extern int __modsi3(int, int);
-extern long __moddi3(long, long);
-extern long long __modti3(long long, long long);
+extern long long __moddi3(long long, long long);
 
 extern unsigned int __umodsi3(unsigned int, unsigned int);
-extern unsigned long __umoddi3(unsigned long, unsigned long);
-extern unsigned long long __umodti3(unsigned long long, unsigned long long);
+extern unsigned long long __umoddi3(unsigned long long, unsigned long long);
 
 extern int __divmodsi3(int, int, int *);
-extern long __divmoddi3(long, long, long *);
-extern long long __divmodti3(long long, long long, long long *);
+extern unsigned int __udivmodsi3(unsigned int, unsigned int, unsigned int *);
 
-extern unsigned int __udivmodsi3(unsigned int, unsigned int, unsigned int *);
-extern unsigned long __udivmoddi3(unsigned long, unsigned long,
-    unsigned long *);
-extern unsigned long long __udivmodti3(unsigned long long, unsigned long long,
+extern long long __divmoddi3(long long, long long, long long *);
+extern long long __divmoddi4(long long, long long, long long *);
+extern unsigned long long __udivmoddi3(unsigned long long, unsigned long long,
     unsigned long long *);
-
-extern int __divmodsi4(int, int, int *);
-extern long __divmoddi4(long, long, long *);
-extern long long __divmodti4(long long, long long, long long *);
-
-extern unsigned int __udivmodsi4(unsigned int, unsigned int, unsigned int *);
-extern unsigned long __udivmoddi4(unsigned long, unsigned long,
-    unsigned long *);
-extern unsigned long long __udivmodti4(unsigned long long, unsigned long long,
+extern unsigned long long __udivmoddi4(unsigned long long, unsigned long long,
     unsigned long long *);
 
Index: uspace/lib/softint/include/multiplication.h
===================================================================
--- uspace/lib/softint/include/multiplication.h	(revision 33b8d024bc268f2773c26e74a40dada11bb71e58)
+++ uspace/lib/softint/include/multiplication.h	(revision 2467b4174c7fecef314011212ab09a004872362d)
@@ -38,6 +38,5 @@
 
 /* 64 bit multiplication */
-extern long __muldi3(long, long);
-extern long long __multi3(long long, long long);
+extern long long __muldi3(long long, long long);
 
 #endif
Index: uspace/lib/softint/include/shift.h
===================================================================
--- uspace/lib/softint/include/shift.h	(revision 33b8d024bc268f2773c26e74a40dada11bb71e58)
+++ uspace/lib/softint/include/shift.h	(revision 2467b4174c7fecef314011212ab09a004872362d)
@@ -38,14 +38,11 @@
 
 /* Arithmetic/logical shift left. */
-extern long __ashldi3(long, int);
-extern long long __ashlti3(long long, int);
+extern long long __ashldi3(long long, int);
 
 /* Arithmetic shift right. */
-extern long __ashrdi3(long, int);
-extern long long __ashrti3(long long, int);
+extern long long __ashrdi3(long long, int);
 
 /* Logical shift right. */
-extern long __lshrdi3(long, int);
-extern long long __lshrti3(long long, int);
+extern long long __lshrdi3(long long, int);
 
 